# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CloudAccountRegionEnumerationSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cloud_account_type': 'str',
        'private_key_id': 'str',
        'private_key': 'str',
        'cloud_account_id': 'str',
        'cloud_account_properties': 'dict(str, str)',
        'certificate_info': 'IaasapiintegrationsCertificateInfo'
    }

    attribute_map = {
        'cloud_account_type': 'cloudAccountType',
        'private_key_id': 'privateKeyId',
        'private_key': 'privateKey',
        'cloud_account_id': 'cloudAccountId',
        'cloud_account_properties': 'cloudAccountProperties',
        'certificate_info': 'certificateInfo'
    }

    def __init__(self, cloud_account_type=None, private_key_id=None, private_key=None, cloud_account_id=None, cloud_account_properties=None, certificate_info=None):  # noqa: E501
        """CloudAccountRegionEnumerationSpecification - a model defined in Swagger"""  # noqa: E501
        self._cloud_account_type = None
        self._private_key_id = None
        self._private_key = None
        self._cloud_account_id = None
        self._cloud_account_properties = None
        self._certificate_info = None
        self.discriminator = None
        if cloud_account_type is not None:
            self.cloud_account_type = cloud_account_type
        if private_key_id is not None:
            self.private_key_id = private_key_id
        if private_key is not None:
            self.private_key = private_key
        if cloud_account_id is not None:
            self.cloud_account_id = cloud_account_id
        self.cloud_account_properties = cloud_account_properties
        if certificate_info is not None:
            self.certificate_info = certificate_info

    @property
    def cloud_account_type(self):
        """Gets the cloud_account_type of this CloudAccountRegionEnumerationSpecification.  # noqa: E501

        Cloud account type  # noqa: E501

        :return: The cloud_account_type of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._cloud_account_type

    @cloud_account_type.setter
    def cloud_account_type(self, cloud_account_type):
        """Sets the cloud_account_type of this CloudAccountRegionEnumerationSpecification.

        Cloud account type  # noqa: E501

        :param cloud_account_type: The cloud_account_type of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._cloud_account_type = cloud_account_type

    @property
    def private_key_id(self):
        """Gets the private_key_id of this CloudAccountRegionEnumerationSpecification.  # noqa: E501

        Access key id or username to be used to authenticate with the cloud account. Either provide privateKeyId or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The private_key_id of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._private_key_id

    @private_key_id.setter
    def private_key_id(self, private_key_id):
        """Sets the private_key_id of this CloudAccountRegionEnumerationSpecification.

        Access key id or username to be used to authenticate with the cloud account. Either provide privateKeyId or provide a cloudAccountId of an existing account.  # noqa: E501

        :param private_key_id: The private_key_id of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._private_key_id = private_key_id

    @property
    def private_key(self):
        """Gets the private_key of this CloudAccountRegionEnumerationSpecification.  # noqa: E501

        Secret access key or password to be used to authenticate with the cloud account. Either provide privateKey or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The private_key of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._private_key

    @private_key.setter
    def private_key(self, private_key):
        """Sets the private_key of this CloudAccountRegionEnumerationSpecification.

        Secret access key or password to be used to authenticate with the cloud account. Either provide privateKey or provide a cloudAccountId of an existing account.  # noqa: E501

        :param private_key: The private_key of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._private_key = private_key

    @property
    def cloud_account_id(self):
        """Gets the cloud_account_id of this CloudAccountRegionEnumerationSpecification.  # noqa: E501

        Existing cloud account id. Either provide existing cloud account Id, or privateKeyId/privateKey credentials pair.  # noqa: E501

        :return: The cloud_account_id of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._cloud_account_id

    @cloud_account_id.setter
    def cloud_account_id(self, cloud_account_id):
        """Sets the cloud_account_id of this CloudAccountRegionEnumerationSpecification.

        Existing cloud account id. Either provide existing cloud account Id, or privateKeyId/privateKey credentials pair.  # noqa: E501

        :param cloud_account_id: The cloud_account_id of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._cloud_account_id = cloud_account_id

    @property
    def cloud_account_properties(self):
        """Gets the cloud_account_properties of this CloudAccountRegionEnumerationSpecification.  # noqa: E501

        Cloud Account specific properties supplied in as name value pairs. In case of AAP, provide environment property here. Example: \"cloudAccountProperties\": {         \"environment\": \"aap\"     }  # noqa: E501

        :return: The cloud_account_properties of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._cloud_account_properties

    @cloud_account_properties.setter
    def cloud_account_properties(self, cloud_account_properties):
        """Sets the cloud_account_properties of this CloudAccountRegionEnumerationSpecification.

        Cloud Account specific properties supplied in as name value pairs. In case of AAP, provide environment property here. Example: \"cloudAccountProperties\": {         \"environment\": \"aap\"     }  # noqa: E501

        :param cloud_account_properties: The cloud_account_properties of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :type: dict(str, str)
        """
        if cloud_account_properties is None:
            raise ValueError("Invalid value for `cloud_account_properties`, must not be `None`")  # noqa: E501

        self._cloud_account_properties = cloud_account_properties

    @property
    def certificate_info(self):
        """Gets the certificate_info of this CloudAccountRegionEnumerationSpecification.  # noqa: E501


        :return: The certificate_info of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :rtype: IaasapiintegrationsCertificateInfo
        """
        return self._certificate_info

    @certificate_info.setter
    def certificate_info(self, certificate_info):
        """Sets the certificate_info of this CloudAccountRegionEnumerationSpecification.


        :param certificate_info: The certificate_info of this CloudAccountRegionEnumerationSpecification.  # noqa: E501
        :type: IaasapiintegrationsCertificateInfo
        """

        self._certificate_info = certificate_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CloudAccountRegionEnumerationSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudAccountRegionEnumerationSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
